[inherit('phttp')]
program test(input, output);

procedure test1;

var
   con : http;
   line : pstr;
   lno : integer;

begin
   con := http_get('arne1', 80, '/', '*/*');
   writeln(http_numcode(con):3,' (',http_txtcode2(con),') => ',http_length(con):1,' ',http_contyp2(con));
   lno := 0;
   while http_recv(con, line.body, line.length) >= 0 do begin
      lno := lno + 1;
      writeln(lno:4,': ',line);
   end;
   http_close(con);
end;

procedure test2;

var
   con : http;
   line : pstr;
   lno : integer;

begin
   con := http_get('arne1', 81, '/index.html', '*/*');
   writeln(http_numcode(con):3,' (',http_txtcode2(con),') => ',http_length(con):1,' ',http_contyp2(con));
   lno := 0;
   while http_recv(con, line.body, line.length) >= 0 do begin
      lno := lno + 1;
      writeln(lno:4,': ',line);
   end;
   http_close(con);
end;

procedure test3;

var
   con : http;
   line : pstr;
   lno : integer;

begin
   con := http_post('arne1', 80, '/cgi-bin/tell', 'application/x-www-form-urlencoded', '*/*', 'slf=abc&mlf=xyz');
   writeln(http_numcode(con):3,' (',http_txtcode2(con),') => ',http_length(con):1,' ',http_contyp2(con));
   lno := 0;
   while http_recv(con, line.body, line.length) >= 0 do begin
      lno := lno + 1;
      writeln(lno:4,': ',line);
   end;
   http_close(con);
end;

procedure test4;

var
   con : http;
   txtcode, contyp, line : pstr;
   lno : integer;

begin
   con := http_post('arne1', 81, '/htbin/tell2', 'application/x-www-form-urlencoded', '*/*', 'slf=abc&mlf=xyz');
   writeln(http_numcode(con):3,' (',http_txtcode2(con),') => ',http_length(con):1,' ',http_contyp2(con));
   lno := 0;
   while http_recv(con, line.body, line.length) >= 0 do begin
      lno := lno + 1;
      writeln(lno:4,': ',line);
   end;
   http_close(con);
end;

procedure test5;

var
   con : http;
   line : pstr;
   lno : integer;

begin
   con := http_get('arnepc4', 81, '/testapi.php/t1/123', 'application/xml');
   writeln(http_numcode(con):3,' (',http_txtcode2(con),') => ',http_length(con):1,' ',http_contyp2(con));
   lno := 0;
   while http_recv(con, line.body, line.length) >= 0 do begin
      lno := lno + 1;
      writeln(lno:4,': ',line);
   end;
   http_close(con);
end;

procedure test6;

var
   con : http;
   line : pstr;
   lno : integer;

begin
   con := http_get('arnepc4', 81, '/testapi.php/t1/123', 'application/json');
   writeln(http_numcode(con):3,' (',http_txtcode2(con),') => ',http_length(con):1,' ',http_contyp2(con));
   lno := 0;
   while http_recv(con, line.body, line.length) >= 0 do begin
      lno := lno + 1;
      writeln(lno:4,': ',line);
   end;
   http_close(con);
end;

procedure test7;

var
   con : http;
   line : pstr;
   lno : integer;

begin
   con := http_post('arnepc4', 81, '/testapi.php/t1', 'application/xml', 'application/xml', '<t1><f1>123</f1><f2>ABC</f2></t1>');
   writeln(http_numcode(con):3,' (',http_txtcode2(con),') => ',http_length(con):1,' ',http_contyp2(con));
   lno := 0;
   while http_recv(con, line.body, line.length) >= 0 do begin
      lno := lno + 1;
      writeln(lno:4,': ',line);
   end;
   http_close(con);
end;

procedure test8;

var
   con : http;
   line : pstr;
   lno : integer;

begin
   con := http_post('arnepc4', 81, '/testapi.php/t1', 'application/json', 'application/json', '{"f1":123,"f2":"ABC"}');
   writeln(http_numcode(con):3,' (',http_txtcode2(con),') => ',http_length(con):1,' ',http_contyp2(con));
   lno := 0;
   while http_recv(con, line.body, line.length) >= 0 do begin
      lno := lno + 1;
      writeln(lno:4,': ',line);
   end;
   http_close(con);
end;

begin
   test1;
   test2;
   test3;
   test4;
   test5;
   test6;
   test7;
   test8;
end.
